!*******************************************************
!*
!* MODULE for the routines used to initialized
!* the probleme for the second part of the TP2
!*
!*******************************************************

MODULE init_cheby

  !* Module loaded

  USE constants

  USE algebra

contains

  !****************************************************
  !* 
  !* Routine for the initialization of the matrix
  !*
  !* INPUT/OUTPUT
  !*
  !* a :: matrix to initialize
  !*
  !****************************************************

  SUBROUTINE init_Matrix(a)

  END SUBROUTINE init_Matrix

  !****************************************************
  !* 
  !* Routine applying the BCs to the Matrix
  !*
  !* INPUT/OUTPUT
  !*
  !* a :: matrix to initialize
  !*
  !****************************************************

  SUBROUTINE apply_BC_Matrix(a)

  END SUBROUTINE apply_BC_Matrix

  !****************************************************
  !* 
  !* Routine for the initialization of the right hand
  !* side
  !*
  !* INPUT/OUTPUT
  !*
  !* b :: right hand side initialized
  !*
  !****************************************************

  SUBROUTINE init_RHS(b)

  END SUBROUTINE init_RHS

  !****************************************************
  !* 
  !* Routine applying the BCs to the right hand side
  !*
  !* INPUT/OUTPUT
  !*
  !* b :: right hand side initialized
  !*
  !****************************************************

  SUBROUTINE apply_BC_RHS(b)

  END SUBROUTINE apply_BC_RHS

  !****************************************************
  !* 
  !* Routine for the initialization of the grid
  !*
  !* INPUT/OUTPUT
  !*
  !* x :: the grid of collocation points
  !*
  !****************************************************

  SUBROUTINE init_Grid(x)

  END SUBROUTINE init_Grid

  !****************************************************
  !* 
  !* Routine for the initialization of the solution
  !*
  !* INPUT/OUTPUT
  !*
  !* x :: the solution
  !*
  !****************************************************

  SUBROUTINE init_Solution(x,grid)

    IMPLICIT NONE

    !* Variables declaration

    REAL(idp), DIMENSION(:) :: x,grid
    INTEGER                 :: i

    !* Code

    Do i=1,size(x,1)
       x(i) = grid(i)*cos(grid(i))
    END Do

  END SUBROUTINE init_Solution

  !****************************************************
  !* 
  !* Routine for the comparison of the solution found
  !* by the user and the real solution
  !*
  !* INPUT
  !*
  !* x :: the solution
  !*
  !****************************************************

  SUBROUTINE compare_To_Solution(x)

    IMPLICIT NONE

    !* Variables declaration

    REAL(idp), DIMENSION(:) :: x
    REAL(idp), DIMENSION(size(x,1)) :: sol,grid

    !* Code

    call init_Grid(grid)

    call init_Solution(sol,grid)

    write(*,*) 'Value of || sol - your_sol || : ', sqrt(DOTPRODUCT(x-sol,x-sol))
  END SUBROUTINE compare_To_Solution

END MODULE init_cheby
